_Display_Init:
;Stretch.mbas,45 :: 		sub procedure Display_Init()
ADDIU	SP, SP, -40
SW	RA, 0(SP)
;Stretch.mbas,46 :: 		TFT_BLED_Direction = 0           ' Set TFT backlight pin as output
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
LUI	R2, BitMask(TRISD2_bit+0)
ORI	R2, R2, BitMask(TRISD2_bit+0)
_SX	
;Stretch.mbas,47 :: 		TFT_Set_Default_Mode()
JAL	_TFT_Set_Default_Mode+0
NOP	
;Stretch.mbas,48 :: 		TFT_Init_ILI9481_8bit(320, 240)  ' Initialize TFT display
ORI	R26, R0, 240
ORI	R25, R0, 320
JAL	_TFT_Init_ILI9481_8bit+0
NOP	
;Stretch.mbas,49 :: 		TFT_BLED = 1                     ' Turn on TFT backlight
LUI	R2, BitMask(LATD2_bit+0)
ORI	R2, R2, BitMask(LATD2_bit+0)
_SX	
;Stretch.mbas,50 :: 		TFT_Fill_Screen(CL_WHITE)
ORI	R25, R0, 65535
JAL	_TFT_Fill_Screen+0
NOP	
;Stretch.mbas,51 :: 		TFT_Set_Pen(CL_WHITE, 1)
ORI	R26, R0, 1
ORI	R25, R0, 65535
JAL	_TFT_Set_Pen+0
NOP	
;Stretch.mbas,52 :: 		TFT_Set_Brush(1,CL_WHITE,0,0,0,0)
MOVZ	R28, R0, R0
MOVZ	R27, R0, R0
ORI	R26, R0, 65535
ORI	R25, R0, 1
ADDIU	SP, SP, -4
SH	R0, 2(SP)
SH	R0, 0(SP)
JAL	_TFT_Set_Brush+0
NOP	
ADDIU	SP, SP, 4
;Stretch.mbas,53 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)
MOVZ	R27, R0, R0
MOVZ	R26, R0, R0
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,54 :: 		TFT_Fill_Screen(CL_WHITE)
ORI	R25, R0, 65535
JAL	_TFT_Fill_Screen+0
NOP	
;Stretch.mbas,55 :: 		TFT_Set_Pen(CL_Black, 1)
ORI	R26, R0, 1
MOVZ	R25, R0, R0
JAL	_TFT_Set_Pen+0
NOP	
;Stretch.mbas,56 :: 		TFT_Line(20, 220, 300, 220)
ORI	R28, R0, 220
ORI	R27, R0, 300
ORI	R26, R0, 220
ORI	R25, R0, 20
JAL	_TFT_Line+0
NOP	
;Stretch.mbas,57 :: 		TFT_LIne(20,  46, 300,  46)
ORI	R28, R0, 46
ORI	R27, R0, 300
ORI	R26, R0, 46
ORI	R25, R0, 20
JAL	_TFT_Line+0
NOP	
;Stretch.mbas,58 :: 		TFT_Set_Font(@TFT_defaultFont, CL_RED, FO_HORIZONTAL)
MOVZ	R27, R0, R0
ORI	R26, R0, 63488
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,59 :: 		TFT_Write_Text("Stretch Click", 85, 14)
ADDIU	R3, SP, 20
ORI	R2, R0, 83
SB	R2, 0(R3)
ORI	R2, R0, 116
SB	R2, 1(R3)
ORI	R2, R0, 114
SB	R2, 2(R3)
ORI	R2, R0, 101
SB	R2, 3(R3)
ORI	R2, R0, 116
SB	R2, 4(R3)
ORI	R2, R0, 99
SB	R2, 5(R3)
ORI	R2, R0, 104
SB	R2, 6(R3)
ORI	R2, R0, 32
SB	R2, 7(R3)
ORI	R2, R0, 67
SB	R2, 8(R3)
ORI	R2, R0, 108
SB	R2, 9(R3)
ORI	R2, R0, 105
SB	R2, 10(R3)
ORI	R2, R0, 99
SB	R2, 11(R3)
ORI	R2, R0, 107
SB	R2, 12(R3)
SB	R0, 13(R3)
ADDIU	R2, SP, 20
ORI	R27, R0, 14
ORI	R26, R0, 85
MOVZ	R25, R2, R0
JAL	_TFT_Write_Text+0
NOP	
;Stretch.mbas,60 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)
MOVZ	R27, R0, R0
MOVZ	R26, R0, R0
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,61 :: 		TFT_Write_Text("EasyPIC Fusion v7", 19, 223)
ADDIU	R3, SP, 20
ORI	R2, R0, 69
SB	R2, 0(R3)
ORI	R2, R0, 97
SB	R2, 1(R3)
ORI	R2, R0, 115
SB	R2, 2(R3)
ORI	R2, R0, 121
SB	R2, 3(R3)
ORI	R2, R0, 80
SB	R2, 4(R3)
ORI	R2, R0, 73
SB	R2, 5(R3)
ORI	R2, R0, 67
SB	R2, 6(R3)
ORI	R2, R0, 32
SB	R2, 7(R3)
ORI	R2, R0, 70
SB	R2, 8(R3)
ORI	R2, R0, 117
SB	R2, 9(R3)
ORI	R2, R0, 115
SB	R2, 10(R3)
ORI	R2, R0, 105
SB	R2, 11(R3)
ORI	R2, R0, 111
SB	R2, 12(R3)
ORI	R2, R0, 110
SB	R2, 13(R3)
ORI	R2, R0, 32
SB	R2, 14(R3)
ORI	R2, R0, 118
SB	R2, 15(R3)
ORI	R2, R0, 55
SB	R2, 16(R3)
SB	R0, 17(R3)
ADDIU	R2, SP, 20
ORI	R27, R0, 223
ORI	R26, R0, 19
MOVZ	R25, R2, R0
JAL	_TFT_Write_Text+0
NOP	
;Stretch.mbas,62 :: 		TFT_Set_Font(@TFT_defaultFont, CL_RED, FO_HORIZONTAL)
MOVZ	R27, R0, R0
ORI	R26, R0, 63488
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,63 :: 		TFT_Write_Text("www.mikroe.com", 200, 223)
ADDIU	R3, SP, 20
ORI	R2, R0, 119
SB	R2, 0(R3)
ORI	R2, R0, 119
SB	R2, 1(R3)
ORI	R2, R0, 119
SB	R2, 2(R3)
ORI	R2, R0, 46
SB	R2, 3(R3)
ORI	R2, R0, 109
SB	R2, 4(R3)
ORI	R2, R0, 105
SB	R2, 5(R3)
ORI	R2, R0, 107
SB	R2, 6(R3)
ORI	R2, R0, 114
SB	R2, 7(R3)
ORI	R2, R0, 111
SB	R2, 8(R3)
ORI	R2, R0, 101
SB	R2, 9(R3)
ORI	R2, R0, 46
SB	R2, 10(R3)
ORI	R2, R0, 99
SB	R2, 11(R3)
ORI	R2, R0, 111
SB	R2, 12(R3)
ORI	R2, R0, 109
SB	R2, 13(R3)
SB	R0, 14(R3)
ADDIU	R2, SP, 20
ORI	R27, R0, 223
ORI	R26, R0, 200
MOVZ	R25, R2, R0
JAL	_TFT_Write_Text+0
NOP	
;Stretch.mbas,64 :: 		end sub
L_end_Display_Init:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 40
JR	RA
NOP	
; end of _Display_Init
_readSensor:
;Stretch.mbas,68 :: 		sub procedure readSensor()
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;Stretch.mbas,69 :: 		adc_rd = ADC1_Get_Sample(8)               ' Get ADC value from corresponding channel
SW	R25, 4(SP)
ORI	R25, R0, 8
JAL	_ADC1_Get_Sample+0
NOP	
SB	R2, Offset(_adc_rd+0)(GP)
;Stretch.mbas,70 :: 		delay_ms(10)                              ' Pause 10ms
LUI	R24, 4
ORI	R24, R24, 4522
L__readSensor2:
ADDIU	R24, R24, -1
BNE	R24, R0, L__readSensor2
NOP	
;Stretch.mbas,71 :: 		end sub
L_end_readSensor:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _readSensor
_set_adc:
;Stretch.mbas,75 :: 		sub procedure set_adc()
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;Stretch.mbas,76 :: 		AD1PCFG = 0xFFEF                        ' Configure AN pins as digital I/O
ORI	R2, R0, 65519
SW	R2, Offset(AD1PCFG+0)(GP)
;Stretch.mbas,77 :: 		JTAGEN_bit = 0                          ' Disable JTAG port
_LX	
INS	R2, R0, BitPos(JTAGEN_bit+0), 1
_SX	
;Stretch.mbas,78 :: 		ADC1_Init()                             ' Init
JAL	_ADC1_Init+0
NOP	
;Stretch.mbas,79 :: 		Delay_ms(100)
LUI	R24, 40
ORI	R24, R24, 45226
L__set_adc5:
ADDIU	R24, R24, -1
BNE	R24, R0, L__set_adc5
NOP	
;Stretch.mbas,80 :: 		end sub
L_end_set_adc:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _set_adc
_main:
;Stretch.mbas,82 :: 		main:
;Stretch.mbas,83 :: 		set_adc()                                                         ' Set A/D register
JAL	_set_adc+0
NOP	
;Stretch.mbas,84 :: 		Display_Init()                                                    ' Initialize TFT
JAL	_Display_Init+0
NOP	
;Stretch.mbas,85 :: 		TFT_Set_Pen(CL_WHITE, 1)
ORI	R26, R0, 1
ORI	R25, R0, 65535
JAL	_TFT_Set_Pen+0
NOP	
;Stretch.mbas,86 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)
MOVZ	R27, R0, R0
MOVZ	R26, R0, R0
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,87 :: 		while TRUE
L__main9:
;Stretch.mbas,88 :: 		readSensor()                                                  ' Read sensor
JAL	_readSensor+0
NOP	
;Stretch.mbas,89 :: 		TFT_Set_Font(@TFT_defaultFont, CL_WHITE, FO_HORIZONTAL)
MOVZ	R27, R0, R0
ORI	R26, R0, 65535
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,90 :: 		TFT_Write_Text(txt, 140, 100)
ORI	R27, R0, 100
ORI	R26, R0, 140
LUI	R25, hi_addr(_txt+0)
ORI	R25, R25, lo_addr(_txt+0)
JAL	_TFT_Write_Text+0
NOP	
;Stretch.mbas,91 :: 		WordToStr(adc_rd,txt)                                         ' Conversion integer adc_rd to string txt
LUI	R26, hi_addr(_txt+0)
ORI	R26, R26, lo_addr(_txt+0)
LBU	R25, Offset(_adc_rd+0)(GP)
JAL	_WordToStr+0
NOP	
;Stretch.mbas,92 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)       ' Display string on TFT
MOVZ	R27, R0, R0
MOVZ	R26, R0, R0
LUI	R25, hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;Stretch.mbas,93 :: 		TFT_Write_Text(txt,140,100)                                   ' Print txt value on TFT
ORI	R27, R0, 100
ORI	R26, R0, 140
LUI	R25, hi_addr(_txt+0)
ORI	R25, R25, lo_addr(_txt+0)
JAL	_TFT_Write_Text+0
NOP	
;Stretch.mbas,94 :: 		delay_ms(500)
LUI	R24, 203
ORI	R24, R24, 29524
L__main13:
ADDIU	R24, R24, -1
BNE	R24, R0, L__main13
NOP	
NOP	
NOP	
;Stretch.mbas,95 :: 		wend
J	L__main9
NOP	
L_end_main:
L__main_end_loop:
J	L__main_end_loop
NOP	
; end of _main
